<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/SXRServer.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/SXRServer.py</title>
<link href="../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/SXRServer.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2006 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno">  7</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> IR</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">import</span> os, fnmatch</span>
<a id="line10"></a><span class="lineno"> 10</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/SXRServer.html#escape">escape</a>(text):</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line">    <span class="py-string">&quot;&quot;&quot;escape special characters ('&amp;', '\&quot;', '&lt;', '&gt;')&quot;&quot;&quot;</span></span>
<a id="line13"></a><span class="lineno"> 13</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line">    text = text.replace(<span class="py-string">'&amp;'</span>, <span class="py-string">'&amp;amp;'</span>)</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line">    text = text.replace(<span class="py-string">'&quot;'</span>, <span class="py-string">'&amp;quot;'</span>)</span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line">    text = text.replace(<span class="py-string">'&lt;'</span>, <span class="py-string">'&amp;lt;'</span>)</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line">    text = text.replace(<span class="py-string">'&gt;'</span>, <span class="py-string">'&amp;gt;'</span>)</span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line">    <span class="py-keyword">return</span> text</span>
<a id="line19"></a><span class="lineno"> 19</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line">default_template = <span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line"><span class="py-string">&lt;html&gt;</span></span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line"><span class="py-string">  &lt;head&gt;&lt;title&gt;Synopsis Cross-Reference&lt;/title&gt;&lt;/head&gt;</span></span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line"><span class="py-string">  &lt;body&gt;</span></span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line"><span class="py-string">    &lt;h1&gt;Synopsis Cross-Reference&lt;/h1&gt;</span></span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line"><span class="py-string">    @CONTENT@</span></span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line"><span class="py-string">  &lt;/body&gt;</span></span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line"><span class="py-string">&lt;/html&gt;</span></span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line"><span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line29"></a><span class="lineno"> 29</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">file_search_form = <span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line"><span class="py-string">&lt;table class=\&quot;form\&quot;&gt;</span></span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line"><span class="py-string">  &lt;tr&gt;</span></span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line"><span class="py-string">    &lt;td&gt;Enter a file name to search:&lt;/td&gt;</span></span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line"><span class="py-string">    &lt;td&gt;</span></span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line"><span class="py-string">      &lt;form method=\&quot;get\&quot; action=\&quot;%(script)s/file\&quot;&gt;</span></span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line"><span class="py-string">        &lt;input type=&quot;text&quot; name=&quot;string&quot; value=&quot;&quot; size=&quot;15&quot;/&gt;</span></span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line"><span class="py-string">        &lt;input type=&quot;submit&quot; value=&quot;Find&quot;/&gt;</span></span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line"><span class="py-string">      &lt;/form&gt;</span></span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line"><span class="py-string">    &lt;/td&gt;</span></span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line"><span class="py-string">  &lt;/tr&gt;</span></span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line"><span class="py-string">&lt;/table&gt;</span></span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line"><span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line43"></a><span class="lineno"> 43</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">ident_search_form = <span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line"><span class="py-string">&lt;table class=\&quot;form\&quot;&gt;</span></span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line"><span class="py-string">  &lt;tr&gt;</span></span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line"><span class="py-string">    &lt;td&gt;Enter a variable, type, or function name to search:&lt;/td&gt;</span></span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line"><span class="py-string">    &lt;td&gt;</span></span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line"><span class="py-string">      &lt;form method=\&quot;get\&quot; action=\&quot;%(script)s/ident\&quot;&gt;</span></span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line"><span class="py-string">        &lt;input type=&quot;text&quot; name=&quot;string&quot; value=&quot;&quot; size=&quot;15&quot;/&gt;</span></span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line"><span class="py-string">        &lt;input type=&quot;submit&quot; value=&quot;Find&quot;/&gt;</span></span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line"><span class="py-string">      &lt;/form&gt;</span></span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line"><span class="py-string">    &lt;/td&gt;</span></span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line"><span class="py-string">  &lt;/tr&gt;</span></span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line"><span class="py-string">&lt;/table&gt;</span></span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line"><span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line57"></a><span class="lineno"> 57</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/SXRServer/SXRServer.html">SXRServer</a>:</span>
<a id="line59"></a><span class="lineno"> 59</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/SXRServer/SXRServer.html#__init__">__init__</a>(self, root, cgi_url, src_url,</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">                 template_file = None,</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">                 sxr_prefix=<span class="py-string">'/sxr'</span>):</span>
<a id="line63"></a><span class="lineno"> 63</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">        self.cgi_url = cgi_url</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">        self.src_url = src_url</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">        self.src_dir = os.path.join(root, <span class="py-string">'Source'</span>)</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">        ir = IR.load(os.path.join(root, <span class="py-string">'sxr.syn'</span>))</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">        self.data = ir.sxr</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">        self.index = ir.sxr.index()</span>
<a id="line70"></a><span class="lineno"> 70</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">        <span class="py-keyword">if</span> template_file:</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">            template = open(template_file).read()</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">            template = default_template</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">        self.template = template.split(<span class="py-string">&quot;@CONTENT@&quot;</span>)</span>
<a id="line76"></a><span class="lineno"> 76</span>
<a id="line77"></a><span class="lineno"> 77</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/SXRServer/SXRServer.html#ident_ref">ident_ref</a>(self, file, line, scope):</span>
<a id="line79"></a><span class="lineno"> 79</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">        <span class="py-keyword">if</span> len(scope):</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">           text = <span class="py-string">'::'</span>.join(scope)</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">           text = <span class="py-string">'&lt;global scope&gt;'</span></span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'&lt;a href=\&quot;%s/Source/%s.html#%s\&quot;&gt;%s:%s: %s&lt;/a&gt;'</span>%(self.src_url, file, line, file, line, escape(text))</span>
<a id="line85"></a><span class="lineno"> 85</span>
<a id="line86"></a><span class="lineno"> 86</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/SXRServer/SXRServer.html#file_ref">file_ref</a>(self, file, name = None):</span>
<a id="line88"></a><span class="lineno"> 88</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> name: name = file</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">        name = name[:-5] <span class="py-comment"># strip of trailing '.html'</span></span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">&quot;&lt;a href=\&quot;%s/Source/%s\&quot;&gt;%s&lt;/a&gt;&quot;</span>%(self.src_url, file, name)</span>
<a id="line92"></a><span class="lineno"> 92</span>
<a id="line93"></a><span class="lineno"> 93</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/SXRServer/SXRServer.html#list_refs">list_refs</a>(self, data, name):</span>
<a id="line95"></a><span class="lineno"> 95</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">        html = <span class="py-string">''</span></span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> data.has_key(name): <span class="py-keyword">return</span> <span class="py-string">'\n'</span></span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">        html += <span class="py-string">'&lt;h3&gt;%s&lt;/h3&gt;\n'</span>%escape(<span class="py-string">'::'</span>.join(name))</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">        entry = data[name]</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">        <span class="py-keyword">if</span> entry.definitions:</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">            html += <span class="py-string">'&lt;li&gt;Defined at:&lt;br/&gt;\n'</span></span>
<a id="line102"></a><span class="lineno">102</span><span class="line">            html += <span class="py-string">'&lt;ul&gt;\n'</span></span>
<a id="line103"></a><span class="lineno">103</span><span class="line">            <span class="py-keyword">for</span> file, line, scope <span class="py-keyword">in</span> entry.definitions:</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">                html +=  <span class="py-string">'&lt;li&gt;%s&lt;/li&gt;\n'</span>%(self.ident_ref(file, line, scope))</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">            html += <span class="py-string">'&lt;/ul&gt;&lt;/li&gt;\n'</span></span>
<a id="line106"></a><span class="lineno">106</span><span class="line">        <span class="py-keyword">if</span> entry.calls:</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">            html += <span class="py-string">'&lt;li&gt;Called from:&lt;br/&gt;\n'</span></span>
<a id="line108"></a><span class="lineno">108</span><span class="line">            html += <span class="py-string">'&lt;ul&gt;\n'</span></span>
<a id="line109"></a><span class="lineno">109</span><span class="line">            <span class="py-keyword">for</span> file, line, scope <span class="py-keyword">in</span> entry.calls:</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">                html += <span class="py-string">'&lt;li&gt;%s&lt;/li&gt;\n'</span>%(self.ident_ref(file, line, scope))</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">            html += <span class="py-string">'&lt;/ul&gt;&lt;/li&gt;\n'</span></span>
<a id="line112"></a><span class="lineno">112</span><span class="line">        <span class="py-keyword">if</span> entry.references:</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">            html += <span class="py-string">'&lt;li&gt;Referenced from:&lt;br/&gt;\n'</span></span>
<a id="line114"></a><span class="lineno">114</span><span class="line">            html += <span class="py-string">'&lt;ul&gt;\n'</span></span>
<a id="line115"></a><span class="lineno">115</span><span class="line">            <span class="py-keyword">for</span> file, line, scope <span class="py-keyword">in</span> entry.references:</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">                html += <span class="py-string">'&lt;li&gt;%s&lt;/li&gt;\n'</span>%(self.ident_ref(file, line, scope))</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">            html += <span class="py-string">'&lt;/ul&gt;&lt;/li&gt;\n'</span></span>
<a id="line118"></a><span class="lineno">118</span><span class="line">        <span class="py-keyword">return</span> html</span>
<a id="line119"></a><span class="lineno">119</span>
<a id="line120"></a><span class="lineno">120</span>
<a id="line121"></a><span class="lineno">121</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/SXRServer/SXRServer.html#search_file">search_file</a>(self, pattern):</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Generate a file search listing.&quot;&quot;&quot;</span></span>
<a id="line123"></a><span class="lineno">123</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">        html = self.template[0]</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">        html += file_search_form%{<span class="py-string">'script'</span>: self.cgi_url}</span>
<a id="line126"></a><span class="lineno">126</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">        base_path_len = len(self.src_dir)</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">        <span class="py-keyword">def</span> find(result, base, files):</span>
<a id="line129"></a><span class="lineno">129</span>
<a id="line130"></a><span class="lineno">130</span><span class="line">           result.extend([os.path.join(base[base_path_len + 1:], file)</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">                          <span class="py-keyword">for</span> file <span class="py-keyword">in</span> files</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">                          <span class="py-keyword">if</span> os.path.isfile(os.path.join(base, file)) <span class="py-keyword">and</span></span>
<a id="line133"></a><span class="lineno">133</span><span class="line">                          fnmatch.fnmatch(os.path.splitext(file)[0], pattern)])</span>
<a id="line134"></a><span class="lineno">134</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">        result = []</span>
<a id="line136"></a><span class="lineno">136</span><span class="line">        os.path.walk(self.src_dir, find, result)</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">        <span class="py-keyword">if</span> result:</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">            html += <span class="py-string">'&lt;ul&gt;\n'</span></span>
<a id="line139"></a><span class="lineno">139</span><span class="line">            <span class="py-keyword">for</span> f <span class="py-keyword">in</span> result:</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">                html += <span class="py-string">'&lt;li&gt;%s&lt;/li&gt;\n'</span>%(self.file_ref(f.strip()))</span>
<a id="line141"></a><span class="lineno">141</span><span class="line">            html += <span class="py-string">'&lt;/ul&gt;\n'</span></span>
<a id="line142"></a><span class="lineno">142</span><span class="line">        html += self.template[1]</span>
<a id="line143"></a><span class="lineno">143</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">        <span class="py-keyword">return</span> html</span>
<a id="line145"></a><span class="lineno">145</span>
<a id="line146"></a><span class="lineno">146</span>
<a id="line147"></a><span class="lineno">147</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/SXRServer/SXRServer.html#search_ident">search_ident</a>(self, name, qualified = False):</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Generate an identifier listing.&quot;&quot;&quot;</span></span>
<a id="line149"></a><span class="lineno">149</span>
<a id="line150"></a><span class="lineno">150</span><span class="line">        html = self.template[0]</span>
<a id="line151"></a><span class="lineno">151</span><span class="line">        html += ident_search_form%{<span class="py-string">'script'</span> : self.cgi_url}</span>
<a id="line152"></a><span class="lineno">152</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">        <span class="py-keyword">if</span> qualified:</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">            <span class="py-keyword">if</span> <span class="py-string">'::'</span> <span class="py-keyword">in</span> name:</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">                name = tuple(name.split(<span class="py-string">'::'</span>))</span>
<a id="line156"></a><span class="lineno">156</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line157"></a><span class="lineno">157</span><span class="line">                name = tuple(name.split(<span class="py-string">'.'</span>))</span>
<a id="line158"></a><span class="lineno">158</span><span class="line">            found = False</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">            <span class="py-comment"># Check for exact match</span></span>
<a id="line160"></a><span class="lineno">160</span><span class="line">            <span class="py-keyword">if</span> self.data.has_key(name):</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">                html += <span class="py-string">'Found exact match:&lt;br/&gt;\n'</span></span>
<a id="line162"></a><span class="lineno">162</span><span class="line">                html += self.list_refs(self.data, name)</span>
<a id="line163"></a><span class="lineno">163</span><span class="line">                found = True</span>
<a id="line164"></a><span class="lineno">164</span><span class="line">            <span class="py-comment"># Search for last part of name in index</span></span>
<a id="line165"></a><span class="lineno">165</span><span class="line">            <span class="py-keyword">if</span> self.index.has_key(name[-1]):</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">                matches = self.index[name[-1]]</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">                html += <span class="py-string">'Found (%d) possible matches:&lt;br/&gt;\n'</span>%(len(matches))</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">                html += <span class="py-string">'&lt;ul&gt;\n'</span></span>
<a id="line169"></a><span class="lineno">169</span><span class="line">                <span class="py-keyword">for</span> name <span class="py-keyword">in</span> matches:</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">                    html += self.list_refs(self.data, name)</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">                html += <span class="py-string">'&lt;/ul&gt;\n'</span></span>
<a id="line172"></a><span class="lineno">172</span><span class="line">                found = True</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">            <span class="py-keyword">if</span> <span class="py-keyword">not</span> found:</span>
<a id="line174"></a><span class="lineno">174</span><span class="line">                html += <span class="py-string">&quot;No matches found&lt;br/&gt;\n&quot;</span></span>
<a id="line175"></a><span class="lineno">175</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">        <span class="py-keyword">elif</span> self.index.has_key(name):</span>
<a id="line177"></a><span class="lineno">177</span><span class="line">            matches = self.index[name]</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">            html += <span class="py-string">'Found (%d) possible matches:&lt;br/&gt;\n'</span>%(len(matches))</span>
<a id="line179"></a><span class="lineno">179</span><span class="line">            html += <span class="py-string">'&lt;ul&gt;\n'</span></span>
<a id="line180"></a><span class="lineno">180</span><span class="line">            <span class="py-keyword">for</span> name <span class="py-keyword">in</span> matches:</span>
<a id="line181"></a><span class="lineno">181</span><span class="line">                html += self.list_refs(self.data, name)</span>
<a id="line182"></a><span class="lineno">182</span><span class="line">            html += <span class="py-string">'&lt;/ul&gt;\n'</span></span>
<a id="line183"></a><span class="lineno">183</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line184"></a><span class="lineno">184</span><span class="line">            html += <span class="py-string">'No matches found&lt;br/&gt;\n'</span></span>
<a id="line185"></a><span class="lineno">185</span><span class="line">        html += self.template[1]</span>
<a id="line186"></a><span class="lineno">186</span>
<a id="line187"></a><span class="lineno">187</span><span class="line">        <span class="py-keyword">return</span> html</span>
<a id="line188"></a><span class="lineno">188</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:12 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
